#####################################################################################
#
#	:::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]:::
#				 ___                 _
#				| __| __ _  __ _  __| | _ _  ___  _ __
#				| _| / _` |/ _` |/ _` || '_|/ _ \| '_ \
#				|___|\__, |\__, |\__,_||_|  \___/| .__/
#				     |___/ |___/                 |_|
#
#####################################################################################
#
# genbred.tcl v1.0
#
#    3-  .
#
#  : http://flexx.kiev.ua/generator.html
#
#####################################################################################
# 
# : 1)     scripts
#			 2)  eggdrop.conf  source scripts/genbred.tcl
#
# .chanset # [+|-]genbred - |    
#
# : ! -    ;
#				 !  -     ;
#				 !  -     ;
#				 !  -     ;
#				 !  -     ;
#
#####################################################################################
#
#	06.04.2008
#	v1.0 Edit by adium
#	-    .
#
#####################################################################################

namespace eval genbred {
	variable author			{adium@RusNet}
	variable version		{1.0}
	variable date			{06-APR-2008}
	variable unamespace		[string range [namespace current] 2 end]
	variable chflag			$unamespace
	variable pause			{30}
	
	setudef flag			$chflag
	
	if {![info exists egglib(ver)]} {
		setudef flag		usecolors
	}

	variable prefix			{!}
	variable flags			{-|-}

	variable binds			{genbred  bred }

	foreach b [split $binds " "] {
		bind pub ${flags} "${prefix}${b}" ::genbred::main
	}

	proc main {nick uhost hand chan text} {
		variable chflag
		if {![channel get $chan $chflag]} { return 0 }
		set text [lindex [string range [join $text] 0 end] 0]
		variable pause
		variable lastcall
		if {[info exists lastcall($uhost)]} {
			if {[expr [expr [unixtime] - $lastcall($uhost)] < $pause]} {
				set det [expr [unixtime] - $lastcall($uhost)]
				set wtime [expr $pause - $det]
				variable prefix
				putserv "NOTICE $nick :\00314    \00304${prefix}genbred\00314  \00310[timereplace $wtime]\003"
				return 0
			}
		}
		set lastcall($uhost) [unixtime]
		
		switch -- $text {
			{male} - {} {
				set url "http://flexx.kiev.ua/generator.html?sex=male"
			}
			{female} - {} {
				set url "http://flexx.kiev.ua/generator.html?sex=female"
			}
			{mean} - {} {
				set url "http://flexx.kiev.ua/generator.html?sex=mean"
			}
			{mult} - {} {
				set url "http://flexx.kiev.ua/generator.html?sex=mult"
			}
			default { set url "http://flexx.kiev.ua/generator.html" }
		}
		set agent "Mozilla"
		set genbred(agent) [::http::config -useragent $agent]
		set genbred(url) [::http::geturl "$url" -timeout 15000]
		set html [::http::data $genbred(url)]
		::http::cleanup $genbred(url)
		regexp -- {<ol>(.*?)</ol>} $html -> page
		regsub -all -- {<li>} $page {} page
		regsub -all -- {</li>} $page {|} res
		set res [string trim $res]
		regsub -all -- {\n} $res {} res
		set res [string trimleft $res]
		if {[channel get $chan usecolors]} {
			putserv "PRIVMSG $chan :\00303 : \00314[lindex [split $res |] [rand [llength [split $res |]]]] \00307|\00314 [lindex [split $res |] [rand [llength [split $res |]]]] \00307|\00314 [lindex [split $res |] [rand [llength [split $res |]]]]\003"
		} else {
			putserv "PRIVMSG $chan : : [lindex [split $res |] [rand [llength [split $res |]]]] | [lindex [split $res |] [rand [llength [split $res |]]]] | [lindex [split $res |] [rand [llength [split $res |]]]]"
		}
	}

	proc timereplace {text} {
		set text [duration $text]
		set t [lindex $text end-1]
		set m [lindex $text end-3]
		set ti 0
		set mi 0

		if {$t == "0" || $t == "11" || $t == "12" || $t == "13" || $t == "14"} {
			regsub -all -- {seconds} $text {} text
			set ti 1
		} elseif {$t == "1"} {
			regsub -all -- {second} $text {} text
			set ti 1
		} elseif {$t == "2" || $t == "3" || $t == "4"} {
			regsub -all -- {seconds} $text {} text
			set ti 1
		} elseif {$t >= 5 && !$ti} {
			switch -- [string index $t end] { 
				0 { regsub -all -- {seconds} $text {} text }
				1 { regsub -all -- {seconds} $text {} text }
				2 - 3 - 4 { regsub -all -- {seconds} $text {} text }
				default { regsub -all -- {seconds} $text {} text }
			}
		}
		if {$m == "0" || $m == "11" || $m == "12" || $m == "13" || $m == "14"} {
			regsub	-all	--	{minutes}	$text	{}		text
			set mi 1
		} elseif {$m == "1"} {
			regsub	-all	--	{minute}	$text	{}	text
			set mi 1
		} elseif {$m == "2" || $m == "3" || $m == "4"} {
			regsub	-all	--	{minutes}	$text	{}	text
			set mi 1
		} elseif {$m >= 5 && !$mi} {
			switch -- [string index $m end] {
				0 { regsub -all -- {minutes} $text {} text }
				1 { regsub -all -- {minutes} $text {} text }
				2 - 3 - 4 { regsub -all -- {minutes} $text {} text }
				default { regsub -all -- {minutes} $text {} text }
			}
		}
		return $text
	}

	putlog "genbred.tcl by adium loaded"
}